SystemOrganization addCategory: #StatPseudoCollections!

SequenceableCollection subclass: #CodeBook
	instanceVariableNames: 'codes codeLength multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!CodeBook classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^self new
		codes: aCollection;
		codeLength: anInteger;
		yourself
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:13'!
at: anInteger

	^((self multiQuoAndRem value: anInteger-1) copyToEndFrom: 2) collect: [:each| self codes at: each + 1 ]
	! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength

	^codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codeLength: anInteger 

	multiQuoAndRem := nil.
	^codeLength := anInteger
! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes

	^codes! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
codes: anArray 

	multiQuoAndRem := nil.
	^codes := anArray! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil
		ifTrue:
			[multiQuoAndRem := MultiQuoAndRem new.
			multiQuoAndRem dividers: (self codeLength copiesOf: self codes size)
			].
	^multiQuoAndRem! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self codes size raisedTo: self codeLength! !

!CodeBook methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

SequenceableCollection subclass: #Combinations
	instanceVariableNames: 'choices length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!Combinations commentStamp: 'hjo 6/2/2008 20:09' prior: 0!
this is total reimplementation of mathematical operation 'combination'.
this although the class names is same with my Dolphin implementation Combination, but its meaning is very different.
This squeak version is more true to mathematical definition.
!

!Combinations classSide methodsFor: 'examples' stamp: 'hjo 4/15/2008 17:16'!
example

	^self of: #($a $a $a $b $b) length: 5! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:20'!
of: anArray

	^(anArray collect: [:each| self of: anArray length: each ]) concatenateAll! !

!Combinations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:19'!
of: anArray length: anInteger

	^self new choices: anArray; length: anInteger! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:21'!
asArrayedCollection

	^self asArray! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:05'!
at: anInteger

	| index |
	^self length = 1 
		ifTrue: [ {self choices at: anInteger} ]
		ifFalse: [ 
			index := anInteger.
			1 to: self choices size -1 
				do: [:each| | subCombination |
					subCombination := self subCombinationAtChoiceIndex: each. 
					index <= subCombination size 
						ifTrue: [^{self choices at: each}, (subCombination at: index)] 
						ifFalse: [index:=index-subCombination size]
			]
		]! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:27'!
choices: anArray 

	choices := anArray! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	^length
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	length := anInteger 
! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:30'!
size

	^self length combinationOutOf: self choices size! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:00'!
subCombinationAtChoiceIndex: anInteger

	^self class of: (self choices copyToLastFrom: anInteger+1) length: self length-1! !

!Combinations methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:00'!
subCombinations

	^(1 to: self choices size-1) collect: [:each| 
		self subCombinationAtChoiceIndex: each
		]! !

SequenceableCollection subclass: #Permutations
	instanceVariableNames: 'choices length multiQuoAndRem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: anArray 

	^self of: anArray length: anArray size! !

!Permutations classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection length: anInteger

	^super new
		of: aCollection ;
		length: anInteger ;
		yourself! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
at: anInteger 

	| stream unchosen |
	stream := WriteStream on: (Array new: self length).
	unchosen := self choices copy.
	(self multiQuoAndRem indexValue: anInteger-1) do: [:each | stream nextPut: (unchosen removeAtIndex: each) ].
	^stream contents
	! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
choices

	^choices! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length

	length isNil ifTrue: [ self length: self choices size ].
	^length! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
length: anInteger 

	multiQuoAndRem := nil.
	^length := anInteger! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
multiQuoAndRem

	multiQuoAndRem isNil 
		ifTrue:
		[ (multiQuoAndRem := MultiQuoAndRem new) dividers: (self choices size to: self choices size - self length + 1 by: -1) asArray ].
	^multiQuoAndRem! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
of: aCollection 

	multiQuoAndRem := nil.
	^choices := aCollection asOrderedCollection! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
size

	^self length permutationOutOf: self choices size! !

!Permutations methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
species

	^Array! !

TestCase subclass: #CodeBookTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testAccess

	|cb|
	cb := CodeBook new
		codes: #( $a 1 'hi' );
		codeLength: 5;
		yourself.

	self assert: cb size = (3 raisedTo: 5).
	self assert: ( cb at: 1 ) = #( $a $a $a $a $a ).
	self assert: ( cb at: 2 ) = #( $a $a $a $a 1 ).
	self assert: ( cb at: 3 ) = #( $a $a $a $a 'hi' ).
	self assert: ( cb at: 4 ) = #( $a $a $a 1 $a ).
	self assert: ( cb at: 5 ) = #( $a $a $a 1 1 ).
	self assert: ( cb at: 6 ) = #( $a $a $a 1 'hi' ).
	self assert: ( cb at: (3 raisedTo: 5) ) = #( 'hi' 'hi' 'hi' 'hi' 'hi' ).
! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 18:05'!
testCollect

	| collected |
	collected := (CodeBook of: #( 10 1 ) length: 2) collect: [:each | each first + each second ].
	
	self 
		assert: collected size = 4;
		assert: ( collected includesAllOf: #( 2 11 20 ) )! !

!CodeBookTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2008 17:16'!
testSelect

	self assert: 
		((CodeBook of: #( false true ) length: 2) select: [:each | each first and: [each second] ]) size = 1! !

TestCase subclass: #CombinationsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:21'!
test3c1

	self assert: ((Combinations of: 'abc' length: 1) equalElementsTo: #(#($a) #($b) #($c)))! !

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 20:06'!
test3c2

	self assert: ((Combinations of: 'abc' length: 2) equalElementsTo: #(#($a $b) #($a $c) #($b $c)))! !

!CombinationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:42'!
test3c3

	self assert: ((Combinations of: 'abc' length: 3) equalElementsTo: #(#($a $b $c)))! !

TestCase subclass: #PermutationsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StatPseudoCollections'!

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:16'!
test3p1

	self assert: ((Permutations of: 'abc' length: 1) equalElementsTo: #(#($a) #($b) #($c)))! !

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:17'!
test3p2

	self assert: ((Permutations of: 'abc' length: 2) equalElementsTo: #(#($a $b) #($a $c) #($b $a) #($b $c) #($c $a) #($c $b)))! !

!PermutationsTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:18'!
test3p3

	self assert: ((Permutations of: 'abc' length: 3) equalElementsTo: #(#($a $b $c) #($a $c $b) #($b $a $c) #($b $c $a) #($c $a $b) #($c $b $a)))! !
